
using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using RMYY_CallCenter_Api.DB;

namespace RMYY_CallCenter_Api.DAL
{
    /// <summary>
    /// 数据访问类:T_Wo_VisitResult
    /// </summary>
    public partial class T_Wo_VisitResult
    {
        public T_Wo_VisitResult()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_ID", "T_Wo_VisitResult");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Wo_VisitResult");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(RMYY_CallCenter_Api.Model.T_Wo_VisitResult model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Wo_VisitResult(");
            strSql.Append("F_WorkOrderCode,F_Phone,F_Callid,F_CallResult,F_Result,F_Satisfaction,F_CreateTime,F_IsDelete,F_CreateUser)");
            strSql.Append(" values (");
            strSql.Append("@F_WorkOrderCode,@F_Phone,@F_Callid,@F_CallResult,@F_Result,@F_Satisfaction,@F_CreateTime,@F_IsDelete,@F_CreateUser)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Phone", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Callid", SqlDbType.Int,4),
                    new SqlParameter("@F_CallResult", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Result", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_Satisfaction", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUser", SqlDbType.NVarChar,50)};
            parameters[0].Value = model.F_WorkOrderCode;
            parameters[1].Value = model.F_Phone;
            parameters[2].Value = model.F_Callid;
            parameters[3].Value = model.F_CallResult;
            parameters[4].Value = model.F_Result;
            parameters[5].Value = model.F_Satisfaction;
            parameters[6].Value = model.F_CreateTime;
            parameters[7].Value = model.F_IsDelete;
            parameters[8].Value = model.F_CreateUser;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(RMYY_CallCenter_Api.Model.T_Wo_VisitResult model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Wo_VisitResult set ");
            strSql.Append("F_WorkOrderCode=@F_WorkOrderCode,");
            strSql.Append("F_Phone=@F_Phone,");
            strSql.Append("F_Callid=@F_Callid,");
            strSql.Append("F_CallResult=@F_CallResult,");
            strSql.Append("F_Result=@F_Result,");
            strSql.Append("F_Satisfaction=@F_Satisfaction,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_IsDelete=@F_IsDelete,");
            strSql.Append("F_CreateUser=@F_CreateUser");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Phone", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Callid", SqlDbType.Int,4),
                    new SqlParameter("@F_CallResult", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Result", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_Satisfaction", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.F_WorkOrderCode;
            parameters[1].Value = model.F_Phone;
            parameters[2].Value = model.F_Callid;
            parameters[3].Value = model.F_CallResult;
            parameters[4].Value = model.F_Result;
            parameters[5].Value = model.F_Satisfaction;
            parameters[6].Value = model.F_CreateTime;
            parameters[7].Value = model.F_IsDelete;
            parameters[8].Value = model.F_CreateUser;
            parameters[9].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Wo_VisitResult ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Wo_VisitResult ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Wo_VisitResult GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,F_WorkOrderCode,F_Phone,F_Callid,F_CallResult,F_Result,F_Satisfaction,F_CreateTime,F_IsDelete,F_CreateUser from T_Wo_VisitResult ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            RMYY_CallCenter_Api.Model.T_Wo_VisitResult model = new RMYY_CallCenter_Api.Model.T_Wo_VisitResult();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Wo_VisitResult DataRowToModel(DataRow row)
        {
            RMYY_CallCenter_Api.Model.T_Wo_VisitResult model = new RMYY_CallCenter_Api.Model.T_Wo_VisitResult();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["F_WorkOrderCode"] != null)
                {
                    model.F_WorkOrderCode = row["F_WorkOrderCode"].ToString();
                }
                if (row["F_Phone"] != null)
                {
                    model.F_Phone = row["F_Phone"].ToString();
                }
                if (row["F_Callid"] != null && row["F_Callid"].ToString() != "")
                {
                    model.F_Callid = int.Parse(row["F_Callid"].ToString());
                }
                if (row["F_CallResult"] != null)
                {
                    model.F_CallResult = row["F_CallResult"].ToString();
                }
                if (row["F_Result"] != null)
                {
                    model.F_Result = row["F_Result"].ToString();
                }
                if (row["F_Satisfaction"] != null && row["F_Satisfaction"].ToString() != "")
                {
                    model.F_Satisfaction = int.Parse(row["F_Satisfaction"].ToString());
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_IsDelete"] != null && row["F_IsDelete"].ToString() != "")
                {
                    model.F_IsDelete = int.Parse(row["F_IsDelete"].ToString());
                }
                if (row["F_CreateUser"] != null)
                {
                    model.F_CreateUser = row["F_CreateUser"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,F_WorkOrderCode,F_Phone,F_Callid,F_CallResult,F_Result,F_Satisfaction,F_CreateTime,F_IsDelete,F_CreateUser ");
            strSql.Append(" FROM T_Wo_VisitResult ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ID,F_WorkOrderCode,F_Phone,F_Callid,F_CallResult,F_Result,F_Satisfaction,F_CreateTime,F_IsDelete,F_CreateUser ");
            strSql.Append(" FROM T_Wo_VisitResult ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Wo_VisitResult ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Wo_VisitResult T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Wo_VisitResult";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}

